unit Unit1;
{ (c) Epsylon Technologies 1996

 mailto  : dima@demo.ru
 web     : http://ib.demo.ru
 listserv: ib@demo.ru }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, IBPROC32, DBTables, Buttons;

type
  TMainForm = class(TForm)
    Timer1: TTimer;
    LTF: TLabel;
    LMW: TLabel;
    LPR: TLabel;
    LPW: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    BitBtn1: TBitBtn;
    Database1: TDatabase;
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ReadAllInfo;
  end;

var
  MainForm: TMainForm;
  dbHandle : isc_db_handle; { native handle      IB API}
  LibHandle :THandle; { handle  GDS32.DLL - InterBase API }

implementation uses BDE;

{$R *.DFM}

{   isc_database_info   
 ,    isc_info_end 

There must be an array created before call to isc_database_info,
and array must be ended by isc_info_end flag }

const AllInfo : array [0..4] of byte = (isc_info_fetches,
                                       isc_info_marks,
                                       isc_info_reads,
                                       isc_info_writes,
                                       isc_info_end);

procedure TMainForm.ReadAllInfo;
 var
  pnum: word;    {parameter type /      }
  pvar: integer; {statistics value /  , .   }
  pc: PChar;
  rlen: word;
  rbuf: array [0..512] of byte; { output buffer /      }
  stat: isc_status;
  sv: status_vector;
 begin
  rlen:=SizeOf(rbuf);
  { call function to get info /       }
  stat:=ISCDatabaseInfo(@sv, @dbhandle, SizeOf(allinfo), @allinfo, rlen, @rbuf);

  pc:=@rbuf;

  while pc[0] <> char(isc_info_end) do
   begin
    pnum:=byte(pc[0]); Inc(pc); { parameter type byte /    }
    rlen:=word(pc[0]); Inc(pc, 2); { word of parameter length /     }
    Move(pc[0], pvar, SizeOf(pvar));
    case pnum of
     isc_info_fetches        : Label4.Caption:=Format(': %d', [pvar]);
     isc_info_marks          : Label5.Caption:=Format(': %d', [pvar]);
     isc_info_reads          : Label6.Caption:=Format(': %d', [pvar]);
     isc_info_writes         : Label7.Caption:=Format(': %d', [pvar]);
    end;
    Inc(pc, rlen);
   end;


 end;


procedure TMainForm.Timer1Timer(Sender: TObject);
begin
 ReadAllInfo;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
var rlen: word;
begin
 try
    Timer1.Enabled:=False;
    Database1.Close;
    Database1.Params.Values['SERVER NAME']:=Edit1.Text;
    Database1.Open;
    { get database native handle /  native handle  }
    Check( DbiGetProp( HDBIOBJ(Database1.Handle), dbNATIVEHNDL,
                       @dbhandle, sizeof( isc_db_handle), rlen));
    Timer1.Enabled:=True;
 finally
 end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.HintColor:=clAqua;

 { load IB API }
 LibHandle := LoadLibrary('gds32.dll');
 if LibHandle < 32 then
   raise EDLLLoadError.Create('Unable to load gds32.dll');

  @IscDatabaseInfo := GetProcAddress(LibHandle, 'isc_database_info');
  if @IscDatabaseInfo = nil then
    raise EDLLLoadError.Create('Failed to lookup isc_database_info');

end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 FreeLibrary(LibHandle);
end;

end.
